Unit ADG0C_p;
interface
uses
SysUtils, Math, { Delphi }
Lstruct, Lfunc, AFG0C_p;

procedure ADG0C(var A :Array of Complex; var D1 :Complex;
                var D2 :Integer; N :Integer);

implementation

procedure ADG0C(var A :Array of Complex; var D1 :Complex;
                var D2 :Integer; N :Integer);
var
I :Integer;
label
_1,_2,_3;
begin
AFG0C(A,N);
D1 := Cmplx(1.0,0.0);
D2 := 0;
for I:=1 to N do
 begin
  D1 := MulC(D1,A[(I-1)+(I-1)*N]);
_1:
  if ( (Cabs(D1)) < 1.e0 ) 
   then goto _2;
  D1 := MulC(D1,Cmplx(0.0625,0.0));
  D2 := D2+4;
  goto _1;
_2:
  if ( (Cabs(D1)) >= 0.0625e0 ) 
   then goto _3;
  D1 := MulC(D1,Cmplx(16.0,0.0));
  D2 := D2-4;
  goto _2;
_3:
 end;
end;

end.
